/*
 * atobj-pkt.h --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1997-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 *  $Header: /usr/mash/src/repository/mash/mash-1/atobj/atobj-pkt.h,v 1.8 2002/02/03 03:10:21 lim Exp $
 */

#ifndef ATOBJ_PKT_H
#define ATOBJ_PKT_H

/* for now, include MB definitions */
/* REVIEW: get rid of this! */
#include "mb/mb.h"

#ifdef _MSC_VER
#pragma warning( disable : 4200 )
#endif

typedef u_int32_t AnimationId;
typedef u_int32_t EventId;

typedef srm_src SrcId;

struct AtoPkt_event {
        AnimationId pe_anmId;
        EventId pe_eventId;
        u_int32_t pe_strLen;
        /* followed by a string of len rounded up by 4 */
        char pe_achContent[0];
};

struct AtoPkt_request {
        SrcId pr_srcId;
        AnimationId pr_anmId;
        u_int32_t pr_strLen;
        /* followed by a string of len rounded up by 4 */
        char pr_achContent[0];
};

struct AtoPkt_reply {
        SrcId pr_srcId;             /* original source to get stuff from */
        AnimationId pr_anmId;
        /* all the events should be bunched up into a long string */
        u_int32_t pr_strLen;
        /* followed by a string of len rounded up by 4 */
        char pr_achContent[0];
};

/* right now we assume there is only one animation per source */
struct AtoPkt_SA {
        SrcId sa_srcId;                /* origin of data */
        AnimationId sa_anmId;
        u_int32_t sa_strLen;
        char sa_achSA[0];
};


#ifdef _MSC_VER
#pragma warning( default : 4200 )
#endif

#endif /* #ifdef ATOBJ_PKT_H */
