/*
 * encoder-adpcm.cc --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1995-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

static const char rcsid[] =
    "@(#) $Header: /usr/mash/src/repository/mash/mash-1/audio/encoder-adpcm.cc,v 1.7 2002/02/03 03:10:46 lim Exp $";

#include <string.h>
#include "config.h"
#include "rtp.h"
#include "encoder.h"
#include "pktbuf-rtp.h"
extern "C" {
#include "adpcm.h"
}

class ADPCMEncoder : public PCM_Encoder {
public:
	ADPCMEncoder();
	virtual void encode(u_int32_t ts, u_int8_t* samples, int cc);
protected:
	adpcm_state tstate_;
};

static class ADPCMEncoderClass : public TclClass {
public:
	ADPCMEncoderClass() : TclClass("Module/AudioEncoder/ADPCM") {}
	TclObject* create(int /* argc */, const char*const* /* argv */) {
		return (new ADPCMEncoder);
	}
} adpcm_encoder_class;


ADPCMEncoder::ADPCMEncoder()
{
	memset((char*)&tstate_, 0, sizeof(tstate_));
}

void ADPCMEncoder::encode(u_int32_t ts, u_int8_t* frame, int len)
{
	register int marker = (ts != last_ts_) ? htons(RTP_M) : 0;
	last_ts_ = ts + len;

	pktbuf* pb = pool_->alloc(ts, RTP_PT_DVI);
	rtphdr* rh = (rtphdr*)pb->data;
	rh->rh_flags |= marker;
	u_int8_t* o = (u_int8_t*)(rh + 1);
	*(struct adpcm_state*)o = tstate_;
	HTONS(((struct adpcm_state*)o)->valprev);
	adpcm_coder(frame, o + sizeof(struct adpcm_state), len, &tstate_);
	len = (len >> 1) + sizeof(struct adpcm_state);
	pb->len = len + sizeof(*rh);
	target_->recv(pb);
}
