/*
 * ps.h --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1992-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * @(#) $Header: /usr/mash/src/repository/mash/mash-1/ps/ps.h,v 1.6 2002/02/03 04:14:18 lim Exp $
 */

#ifndef mash_ps_h
#define mash_ps_h

#include "tclcl.h"
#ifndef WIN32
#   include <sys/param.h>
#endif
#include <X11/Xlib.h>

class PSstream;
class DrawOpPSComp;
class View;
class Raster;

class PSinterp : public TclObject {
    public:
	PSinterp();
	virtual ~PSinterp();
	virtual int send(DrawOpPSComp*, View*, PSstream*);
	virtual int busy();
	virtual void interp_page(Window msgwin);
	virtual void interp_done(Window msgwin);
    protected:
	Raster* raster_;
	PSstream* strm_;
	DrawOpPSComp* op_;
	View* view_;
	float scale_;
	char* tmpfile_;
	int tmpfd_;
};

#endif
