/*
 * psvp-init.cc --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1998-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <tclcl.h>
#include <tk.h>
#include "mash-init.h"

/* Declaration of Dali init routines. */
extern "C" {
extern int Tcldvmbasic_Init(Tcl_Interp *interp);
extern int Tcldvmpnm_Init(Tcl_Interp *interp);
extern int Tcldvmmpeg_Init(Tcl_Interp *interp);
extern int Tcldvmgif_Init(Tcl_Interp *interp);
extern int Tcldvmamap_Init(Tcl_Interp *interp);
extern int Tcldvmimap_Init(Tcl_Interp *interp);
extern int Tcldvmbytegeom_Init(Tcl_Interp *interp);
extern int Tcldvmwave_Init(Tcl_Interp *interp);
extern int Tcldvmvision_Init(Tcl_Interp *interp);
extern int Tcldvmkernel_Init(Tcl_Interp *interp);
extern int Tcldvmkpatel_Init(Tcl_Interp *interp);
extern int Tcldvmjpeg_Init(Tcl_Interp *interp);
}

int
Psvp_Init(Tcl_Interp *interp)
{
  /* Dali Init routines. */

  if (Tcldvmbasic_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmbasic_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmpnm_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmpnm_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmmpeg_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmmpeg_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmjpeg_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmjpeg_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmamap_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmamap_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmimap_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmimap_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmgif_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmgif_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmbytegeom_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmbytegeom_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmkernel_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmkernel_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmkpatel_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmkpatel_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmvision_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmvision_Init failed!");
    return TCL_ERROR;
  }
  if (Tcldvmwave_Init (interp) == TCL_ERROR) {
    WIN32_OutputErr(interp, "Tcldvmwave_Init failed!");
    return TCL_ERROR;
  }

  return TCL_OK;
}
