# record_session.tcl --
#
#       FIXME: This file needs a description here.
#
# Copyright (c) 1996-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


# Some ad-hoc code I wrote so that recording could be started from sdr.
# Can go away soon.

set sdp ""
while { [gets stdin line] > 0 } {
	if { $sdp=="" && [string index $line 0]!="v" } {
		# bug in sdr; the first line isn't always v=
		# ignore all lines until we get a v=
		continue
	}
	append sdp "$line\n"
}

exec recorder -sdp $sdp &
exit



# none of the following code will be executed


set output [open "|recorder -sdp &" w]

while { [gets stdin line] > 0 } {
	puts $output $line
}

close $output
exit

#  Ad hoc glue to allow recording to be started from SDR


set data ""
set x 0

set filename [lindex $argv 0].hdr
set fileid [open $filename "w"]


puts $fileid "START_SDP"
puts $fileid "\n"

while {[gets stdin data]>0} {
	puts $fileid $data
	set i [string index $data 0]
	if {[string compare $i "m"]==0} {
		incr x
	}
	set input($i,$x) $data
}

puts $fileid "END_SDP"
puts $fileid "\n"
close $fileid

set aaddr 0
set vaddr 0


for {set j 1} {$j < [expr $x + 1]} {incr j} {
	set media [string range $input(m,$j) 2 [expr [string wordend $input(m,$j) 4] -1]]
	if {[string compare $media "audio"] == 0 } {
		set port [string range $input(m,$j) 8 [string wordend $input(m,$j) 8]]
		set add [string range $input(c,$j) 9 [string length $input(c,$j)]]
		set add1 [string range $add 0 [expr [string first "/" $add] -1]]
		set aaddr $add1/$port

	}
	if {[string compare $media "video"] == 0 } {
		set port [string range $input(m,$j) 8 [string wordend $input(m,$j) 8]]
		set add [string range $input(c,$j) 9 [string length $input(c,$j)]]
		set add1 [string range $add 0 [expr [string first "/" $add] -1]]
		set vaddr $add1/$port

	}

}


exec recorder $aaddr $vaddr $filename &

exit
