# rtp-record.tcl --
#
#       FIXME: This file needs a description here.
#
# Copyright (c) 1996-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import RTPApplication ArchiveSession/Record AddressBlock RTPRecordAgent

# This class is required so that the recorder can inherit from RTPApplication
# Status: Beta
# Author: Angela Schuett

Class RTPApplication/Recorder -superclass RTPApplication

RTPApplication/Recorder instproc init {media} {
	$self next recorder
	$self add_option sessionType rtpv2
	$self add_option network ip
	$self add_option defaultTTL 15
	$self add_option cname Archive
}

# This class provides RTP specific recording capabilities
# Status: Beta
# Author: Angela Schuett

Class ArchiveSession/Record/RTP -superclass ArchiveSession/Record

ArchiveSession/Record/RTP instproc init { media addr } {
	set media [string tolower $media]
	$self next $media

	set Media [string toupper [string index $media 0]][string range \
			$media 1 end]
	#set ab [new AddressBlock $addr]
	$self set agent_ [new RTPRecordAgent $self $addr]
}


ArchiveSession/Record/RTP instproc destroy { } {
	$self instvar agent_
	delete $agent_
}
