# transmogrify.tcl --
#
#       FIXME: This file needs a description here.
#
# Copyright (c) 1997-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Class Transmog


Transmog instproc parse_args { argv } {
	$self instvar infile_ outfile_

	set len [llength $argv]
	set idx 0
	while { $idx < $len } {
		set option [lindex $argv $idx]
		incr idx
		switch -exact -- $option {
			-in {
				if { $idx >= $len } {
					error "missing argument for\
							-in"
				}
				set arg [lindex $argv $idx]
				set infile_ [lindex $arg 0]
				puts $infile_
				incr idx
			}
			-out {
				if { $idx >= $len } {
					error "missing argument for\
							-out"
				}
				set arg [lindex $argv $idx]
				set outfile_ [lindex $arg 0]
				puts $outfile_
				incr idx
			}


		}
	}
}

Transmog instproc run { } {
	$self instvar infile_ outfile_

	set df [new ArchiveFile/Data]
	$df open "$infile_.dat"
	set if [new ArchiveFile/Index]
	$if open "$infile_.idx"

	set odf [new ArchiveFile/Data]
	$odf open "$outfile_.dat" "w" 0644
	set idf [new ArchiveFile/Index]
	$idf open "$outfile_.idx" "w" 0644

	$df header hdr

	set session [new Edit/$hdr(protocol) ]

	$session datafile $df
	$session indexfile $if
	$session outdata $odf
	$session outindex $idf

	$session find_cut cuts
	puts "Cuts: $cuts(875045939)"
	#return $cuts
	return 1
}

