# application-mgamon.tcl --
#
#       FIXME: This file needs a description here.
#
# Copyright (c) 1997-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# $Header: /usr/mash/src/repository/mash/mash-1/tcl/mgamon/application-mgamon.tcl,v 1.21 2002/02/03 04:27:48 lim Exp $ (UCB)

import Application MGAMonUI

Class MGAMonApplication -superclass Application

MGAMonApplication instproc init argv {
	$self next mgamon

	$self instvar ui_

	set o [$self options]
	$self init_args $o
	$self init_resources $o
	$o parse_args $argv

	# Source the user's hook file if it exists. The function
	# user_hook, which may be defined in this file, will be
	# called at the end of init.
	if {[$o get_option userhookFile] != ""} {
		if {[file isfile [$o get_option userhookFile]] && \
			[file readable [$o get_option userhookFile]]} {
			source [$o get_option userhookFile]
		} else {
			puts stderr "Unable to source \"[$o get_option userhookFile]\". Not a file or not readable."
		}
	}

	$self init_network

	frame .top
	set ui_ [new MGAMonUI .top]
	pack .top -fill both -expand 1

	$self user_hook
}

MGAMonApplication instproc init_args o {
	$o register_option -u userhookFile
	$o register_option -log doLog
	$o register_option -megactrl asCtrl
}

MGAMonApplication instproc init_resources o {
	#FIXME
	$o add_default foundry adobe
	set foundry [$self get_option foundry]

	set helv10  [$self search_font $foundry helvetica medium 10 r]
	set helv10b [$self search_font $foundry helvetica bold 10 r]
	set helv10o [$self search_font $foundry helvetica bold 10 o]
	set helv12b [$self search_font $foundry helvetica bold 14 r]
	set times14 [$self search_font $foundry times medium 16 r]

	option add *Font $helv12b startupFile
	$o add_default medfont $helv12b
	$o add_default smallfont $helv10b
	$o add_default helpFont $times14
	$o add_default entryFont $helv10

	$o add_default defaultTTL 1
	$o add_option asCtrl 224.4.5.24/50000/31
	$o add_default asCtrlBW 20000
}

MGAMonApplication instproc init_network {} {
	set addr [$self get_option defaultCtrlAddr]
	set port [$self get_option defaultCtrlPort]
	set ttl [$self get_option defaultCtrlTTL]
	set bw [$self get_option defaultCtrlBW]
}
