#!/usr/sww/bin/perl

# doarea.pl --
#
#       FIXME: This file needs a description here.
#
# Copyright (c) 2001-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

if(!defined($areaDir=$ARGV[0]))
{
    showUsage();
}
if(!defined($rangeFile=$ARGV[1]))
{
    $rangeFile = "ranges.txt";
}

# defaults
$histSize = 50;
$timeSlice = 250;

# commands
$evaluate = "../utils/evalarea";

# dirs
$tmpDir = "./tmp";

# get the ranges we want
open(INFILE, $rangeFile);
$val = <INFILE>;
chomp($val);
@speakerThresholds = split(/ /, $val);
$val = <INFILE>;
chomp($val);
@leftThresholds = split(/ /, $val);
$val = <INFILE>;
chomp($val);
@centerThresholds = split(/ /, $val);
$val = <INFILE>;
chomp($val);
@rightThresholds = split(/ /, $val);
$val = <INFILE>;
chomp($val);
@histSizes = split(/ /, $val);
$sizeST = $#speakerThresholds + 1;
$sizeLT = $#leftThresholds + 1;
$sizeCT = $#centerThresholds + 1;
$sizeRT = $#rightThresholds + 1;
$sizeHS = $#histSizes + 1;
close(INFILE);

for($p = 0; $p < $sizeHS; $p++)
{
    $histSize = $histSizes[$p];
    for($w = 0; $w < $sizeST; $w++)
    {
	$st = $speakerThresholds[$w];
	for($y = 0; $y < $sizeCT; $y++)
	{
	    $ct = $centerThresholds[$y];
	    for($z = 0; $z < $sizeRT; $z++)
	    {
		$rt = $rightThresholds[$z];
		for($x = 0; $x < $sizeLT; $x++)
		{
		    $lt = $leftThresholds[$x];

		    # actual stuff
		    $result = system "$evaluate $tmpDir/mark.area $areaDir/sim.$st.$lt.$ct.$rt.$histSize.$timeSlice.area";
		    puts(" $st.$lt.$ct.$rt.$histSize.$timeSlice\n");
		}
	    }
	}
    }
}

# subroutines

sub puts
{
    $arg0 = $_[0];

    system("printf \'$arg0\'");
}

sub showUsage
{
    print("Usage: doarea <data directory> [<range file>]\n");
    exit;
}

