#!/usr/sww/bin/perl

# runanalysis.pl --
#
#       FIXME: This file needs a description here.
#
# Copyright (c) 2000-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

if(!defined($baseDir=$ARGV[0]))
{
    print("Usage: runanalysis.pl <basedir> [<st> <lt> <ct> <rt> <histSize> <timeSlice>]\n");
    exit;
}
if(!defined($st=$ARGV[1]))
{
    $st = 30;
}
if(!defined($lt=$ARGV[2]))
{
    $lt = 30;
}
if(!defined($ct=$ARGV[3]))
{
    $ct = 30;
}
if(!defined($rt=$ARGV[4]))
{
    $rt = 30;
}
if(!defined($histSize=$ARGV[5]))
{
    $histSize = 30;
}
if(!defined($timeSlice=$ARGV[6]))
{
    $timeSlice = 250;
}

# directories
$INPUT_DIR = "../tests/work/$baseDir";
$TMP_DIR = "./tmp";
$BIN_DIR = "../utils";
$RESULTS_DIR = "./work/$baseDir/results";
$SIM_DIR = "../sim";
$SIM_OUT_DIR = "./work/$baseDir/sim";

# utilities
$SIM2STATE = "$BIN_DIR/sim2state";
$ANALYZE = "$BIN_DIR/analyze";

$numIndices = `$BIN_DIR/log_num $INPUT_DIR/log.speaker` - 1;

open(OUTFILE, ">$RESULTS_DIR/analyze.out");
print OUTFILE ("Input Dir: $INPUT_DIR\n");
print OUTFILE ("Thresholds:\n");
print OUTFILE ("\tspeaker: $st\n");
print OUTFILE ("\tleft: $lt\n");
print OUTFILE ("\tcenter: $ct\n");
print OUTFILE ("\tright: $rt\n");
print OUTFILE ("Num Indices: $numIndices\n");
print OUTFILE ("\n");
close OUTFILE;

system "$SIM2STATE $SIM_OUT_DIR/sim.$st.$lt.$ct.$rt.$histSize.$timeSlice.out $numIndices > $TMP_DIR/sim.state";

system "$ANALYZE $TMP_DIR/mark.state $TMP_DIR/sim.state $RESULTS_DIR/analyze.stats >> $RESULTS_DIR/analyze.out";

