# myafter.tcl --
#
#       FIXME: This file needs a description here.
#
# Copyright (c) 2000-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Class MyAfter

MyAfter instproc init {} {
    $self instvar curTime_ keys_ events_ index_

    set curTime_ 0
    set index_ 0
}

MyAfter instproc advanceTime {ms} {
    $self instvar curTime_ keys_ events_

    set curTime_ [expr $curTime_ + $ms]

    set evaledSomething 0
    # not really a queue
#    $self printAll
    foreach index [array names keys_] {
	if {[info exists events_($index,time)]} {
	    if {$events_($index,time) <= $curTime_} {
		set callback $events_($index,callback)
#		puts stdout "time=$curTime_: evaling $callback"
		$self cancelProc $index
		eval $callback
		set evaledSomething 1
	    }
	} else {
	    # a callback executed during the same time slot and cancelled
	    #   this one!
#	    puts stdout "Really weird!  evaledSomething is $evaledSomething, index=$index"
	}
    }
}

MyAfter instproc afterProc {time callback} {
    $self instvar curTime_ keys_ events_ index_

#    puts stdout "time is $curTime_, index_ is $index_"
    set keys_($index_) $index_
    set events_($index_,time) [expr $curTime_ + $time]
    set events_($index_,callback) $callback
    incr index_ 1

#    $self printAll

    return [expr $index_ - 1]
}

MyAfter instproc cancelProc {id} {
    $self instvar curTime_ keys_ events_ index_

    if {[info exists keys_($id)]} {
	unset keys_($id)
	unset events_($id,time)
	unset events_($id,callback)
    }
}

MyAfter instproc printAll {} {
    $self instvar curTime_ keys_ events_ index_

    puts stdout "time = $curTime_"
    foreach index [array names keys_] {
	set time $events_($index,time)
	set callback $events_($index,callback)
	puts stdout "$index: $time, $callback"
    }
}

MyAfter instproc getTime {} {
    $self instvar curTime_

    return $curTime_
}
