# application-rf.tcl --
#
#       Creates a RealFollower object and gives it a frame to display in
#
# Copyright (c) 2000-2002 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# A. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
# B. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.
# C. Neither the names of the copyright holders nor the names of its
#    contributors may be used to endorse or promote products derived from this
#    software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Import enable

import Application RealFollower

Class RealFollowerApplication -superclass Application

RealFollowerApplication instproc showUsage {} {
   puts stdout "usage:  rf"
}

RealFollowerApplication instproc getFlags {argv} {
    $self instvar configFile_

    set configFile_ ""

    set state flag
    foreach arg $argv {
	switch -exact -- $state {
	    flag {
		switch -exact -- $arg {
		    -help {
			$self showUsage
			exit
		    }
		    default {
			$self showUsage
			exit
		    }
		}
	    }
	}
    }
}

RealFollowerApplication instproc init {argv} {
    $self instvar rf_
    $self next "realFollower"

    #$self getFlags $argv

    $self initUI

    set rf_ [new RealFollower .rfFrame]
}

RealFollowerApplication instproc initUI {} {
    wm title . "RealFollower"
    wm minsize . 200 100

    # make real follower frame
    frame .rfFrame
    pack .rfFrame -side top

    # make exit button
    button .exit -text "Exit" -command "$self exitApp"
    pack .exit -side bottom
}

RealFollowerApplication instproc exitApp {} {
    $self instvar rf_

    exit
}

