/*
 * tgmb-defs.h --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1998-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 *  @(#) $Header: /usr/mash/src/repository/mash/mash-1/tgmb/client/tgmb-defs.h,v 1.6 2002/02/03 04:17:39 lim Exp $
 */

#ifndef MASH_TGMB_DEFS_H
#define MASH_TGMB_DEFS_H



#define TGMB_VERSION              0x01050201

#define TGMB_CREATOR		  'TGmb'
#define TGMB_APPTYPE              'TGmb'

#define TGMB_DBTYPE_TMP           'STOR'
#define TGMB_DBTYPE_SESSION       'SESS'
#define TGMB_DBTYPE_SESSIDX       'SIDX'

#define TGMB_DBNAME_TMP		  "TopGunMBTmpStorage"
#define TGMB_DBNAME_CACHE_INDEX	  "TopGunMBCacheIndex"

#define TGMB_MAXUSERNAME          64
#define TGMB_MAXHOSTNAME          128
#define TGMB_MAXADDRSPEC          32
#define TGMB_MAXPORTSPEC          10

#define TGMB_DEFAULT_RmxSvr       "208.1.90.52"
#define TGMB_DEFAULT_RmxPort      60000
#define TGMB_DEFAULT_UserName     ""
#define TGMB_DEFAULT_DontSuspend  0
#define TGMB_DEFAULT_Session      "224.4.4.4/6666"

#define MAX_SESSION_URL           32
#define MAX_SESSION_NAME          (MAX_SESSION_URL - 7)


#define APP                       TGMB_Application::Instance()
#define SESSION                   TGMB_Application::Instance()->Session()


/*#define MAXINDEX		  0xffff

#define MbEOP			  (MAXINDEX-1)
#define MbNotPresent		  (MAXINDEX-2)
#define MbInUse			  (MAXINDEX-3)*/


struct SrcId {
	DWord ss_uid;
	DWord ss_addr;
};

struct PageId {
	struct SrcId sid;
	DWord uid;
};

typedef DWord TGMB_ObjectId;

#endif /* #ifdef MASH_TGMB_DEFS_H */
