/*
 * tgmb-enum.h --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1997-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef MASH_TGMB_ENUM_H
#define MASH_TGMB_ENUM_H


#define TGMB_VERSION  0x01050201


enum TGMB_MetadataType {
	MetaCacheExpire=1,
	MetaNoCache,
	MetaContentType,
	MetaAggList
};


enum TGMB_ContentType {
	ContentTGMB_GatewayLoc=200,
	ContentTGMB_CanvasCmds,
	ContentTGMB_Control
};


enum ChunkFragDescr {
	/*descrCmd=1,
	descrId,
	descrSrcId,*/
	descrItemType=1,
	descrCoords,
	descrColor,
	descrFill,
	descrFont,
	descrImage,
	descrWidth,
	descrArrow,
	descrText,
	descrImageZoom,
	descrImageBits,

	descrNewPage,
	descrSrcName,
	descrBeginHandshake,  /* FIXME: unused, remove this */
	descrClientStatus,
	descrResendImage,

	descrTimestamp,

	descrInvalid
};


enum CanvasCmdType {
	cmdCanvasCreate=1,
	cmdCanvasMove,
	cmdCanvasDelete,
	cmdCanvasConfigText,
	cmdCanvasRaise,
	cmdCanvasUndelete,  /* never seen by the client */
	cmdInvalid
};


#ifdef TGMB_CLIENT

enum PageItemType {
	PgItemNone=0,			/* in case we need a no-types object */
	PgItemLine,			/* 1 */
	PgItemRect,			/* 2 */
	PgItemOval,			/* 3 */
	PgItemMLine,			/* 4 */
	PgItemText,			/* 5 */
	PgItemImage,			/* 6 */
	PgItemPS,			/* 7 */
	PgItemInvalid			/* This value i	s really num types + 1 */
};


enum ArrowType {
	ArrowNone=0,		/* no arrows */
	ArrowFirst,		/* 1 */
	ArrowLast,		/* 2 */
	ArrowBoth,		/* 3 */
	ArrowInvalid		/* This value is really num types+1 */
};


#endif



#endif /* MASH_TGMB_ENUM_H */
