dnl configure.in.fx --
dnl
dnl     configuration for Video Effects (FX) Processing Support.
dnl     Disabled by default
dnl
dnl Copyright (c) 2002-2002 The Regents of the University of California.
dnl All rights reserved.
dnl
dnl Redistribution and use in source and binary forms, with or without
dnl modification, are permitted provided that the following conditions are met:
dnl
dnl A. Redistributions of source code must retain the above copyright notice,
dnl    this list of conditions and the following disclaimer.
dnl B. Redistributions in binary form must reproduce the above copyright
dnl    notice, this list of conditions and the following disclaimer in the
dnl    documentation and/or other materials provided with the distribution.
dnl C. Neither the names of the copyright holders nor the names of its
dnl    contributors may be used to endorse or promote products derived from
dnl    this software without specific prior written permission.
dnl
dnl THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
dnl IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
dnl THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
dnl PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
dnl LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
dnl CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
dnl SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
dnl INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
dnl CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
dnl ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
dnl POSSIBILITY OF SUCH DAMAGE.

FX_DEF=""
FX_OBJ=""
FX_INC=""
FX_LIB=""
DALI_SRC_LOCATION="../tcl8.3/library/dali"

AC_ARG_ENABLE(fx, [  --enable-fx		enable video effects processing package], fx_flag=$enableval, fx_flag="no")

AC_ARG_WITH(dali, [  --with-dali=path	specify location of dali source tree], , withval="")

if test "$with_dali" != "" ; then
	DALI_SRC_LOCATION="$with_dali";
fi

if test "$fx_flag" != "no" ; then
	V_FX_DEF="-D__FX_ENABLED__"
	V_FX_OBJ="\$(FX_OBJ)"
	V_FX_INC="-I${DALI_SRC_LOCATION}/include"
	V_FX_LIB="\$(FX_LIB)"
fi

AC_SUBST(V_FX_DEF)
AC_SUBST(V_FX_OBJ)
AC_SUBST(V_FX_INC)
AC_SUBST(V_FX_LIB)
AC_SUBST(DALI_SRC_LOCATION)
