/*
 * Copyright (c) 1997 Carnegie Mellon University. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation is hereby granted (including for commercial or
 * for-profit use), provided that both the copyright notice and this
 * permission notice appear in all copies of the software, derivative
 * works, or modified versions, and any portions thereof, and that
 * both notices appear in supporting documentation, and that credit
 * is given to Carnegie Mellon University in all publications reporting
 * on direct or indirect use of this code or its derivatives.
 *
 * THIS SOFTWARE IS EXPERIMENTAL AND IS KNOWN TO HAVE BUGS, SOME OF
 * WHICH MAY HAVE SERIOUS CONSEQUENCES.  CARNEGIE MELLON PROVIDES THIS
 * SOFTWARE IN ITS ``AS IS'' CONDITION, AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * Carnegie Mellon encourages (but does not require) users of this
 * software to return any improvements or extensions that they make,
 * and to grant Carnegie Mellon the rights to redistribute these
 * changes without encumbrance.
 */

#ifndef INCL_ERR_MSG
#define INCL_ERR_MSG 

#define ERR_MEM_ALLOC       0
#define ERR_MEM_REALLOC     1
#define ERR_INCOMP_SC       2
#define ERR_INCOMPATIBLE_SC 3
#define ERR_INVALID_POINT   4
#define ERR_INVALID_SEG     5
#define ERR_INVALID_POINTER 6
#define ERR_INVALID_DATA    7
#define ERR_FILE_OPEN       8
#define ERR_ADMISSION_FAILURE 9
#define ERR_EMPTY_QUEUES      10
#define ERR_EMPTY_QUEUE       11
#define ERR_INVALID_NODE_TYPE 12
#define ERR_INVALID_STRING_ID 13
#define ERR_INVALID_ID        14
#define ERR_INVALID_SEG1      15
#define ERR_NOT_SESSION       16
#define ERR_SES_STAT_UNCHANGED 17
#define ERR_INVALID_YVAL      18
#define ERR_INVALID_XVAL      19

extern char *ErrMsg[];

#endif



