/*
 * module.h --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1995-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * @(#) $Header: /usr/mash/src/repository/srmv2/net/module.h,v 1.6 2002/02/03 03:03:19 lim Exp $ (LBL)
 */

#ifndef net_module_h
#define net_module_h

#include "config.h"

class SRMv2_pktbuf;

class SRMv2_Buffer {
public:
//	virtual SRMv2_Buffer* copy() = 0;
	virtual void release();
};
class SRMv2_Module {
public:
	SRMv2_Module* next;
	virtual void recv(SRMv2_Buffer*) = 0;
	inline SRMv2_Module* target() { return (target_); }
protected:
	SRMv2_Module();
	SRMv2_Module* target_;
};

class SRMv2_SourceModule : public SRMv2_Module {
public:
	virtual void recv(SRMv2_Buffer*) {}
};

class SRMv2_PacketModule : public SRMv2_Module {
public:
	virtual void recv(SRMv2_Buffer* p) {
		recv((SRMv2_pktbuf*)p);
	}
	virtual void recv(SRMv2_pktbuf* pb) = 0;
};


#endif
