/*
 * udpchan.cc --
 *
 *      FIXME: This file needs a description here.
 *
 * Copyright (c) 1998-2002 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * A. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * B. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * C. Neither the names of the copyright holders nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
 * IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "net.h"
#include "iohandler.h"


class UDPChannel : public SessionHandler {
    public:
	UDPChannel(int mtu);
	~UDPChannel();
	virtual void recv(DataHandler* dh);

    protected:
	DataHandler dh_;
	u_char* pktbuf_;
	char* cmdbuf_;
	int mtu_;

	virtual void recv(CtrlHandler*) {}
	virtual void announce(CtrlHandler*) {}
};

UDPChannel::UDPChannel(int mtu) : mtu_(mtu)
{
	pktbuf_ = new u_char[2*mtu];
	cmdbuf_ = new char[2*mtu];
	dh_.manager(this);
}

UDPChannel::~UDPChannel()
{
	delete[] pktbuf_;
	delete[] cmdbuf_;
}

void
UDPChannel::recv(DataHandler* dh)
{
	u_int32_t addr;
	int cc = dh->recv(pktbuf_, 2*mtu_, addr);
	if (cc < 0) {
		perror("recv");
		return;
	}
	if (cc == 0)
		return;
	/* FIXME This used to have a tcl upcall, and may not 
	 * behave properly without it. 
	 */
	printf("Warning: Tcl upcall removed. UDPchan no longer works without tclcl.\n");
	return;
}
